(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ng-mix-ui', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ng-mix-ui'] = {}, global.ng.core, global.ng.common));
}(this, (function (exports, i0, common) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (_)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        Object.defineProperty(o, k2, { enumerable: true, get: function () { return m[k]; } });
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    ;
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }
    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var CellComponent = /** @class */ (function () {
        function CellComponent() {
            this.alignActive = '';
            this.alignBreaks = [];
        }
        CellComponent.prototype.ngOnInit = function () {
            this.setAlignBreaks();
            this.setAlignActive();
            this.applyAlign();
        };
        CellComponent.prototype.setAlignBreaks = function () {
            if (!this.alignValue)
                return;
            var pairs = this.alignValue.split(' ');
            var pairSplit;
            this.alignBreaks = pairs.map(function (pair) {
                if (pair.match(/:/)) {
                    pairSplit = pair.split(':');
                    pairSplit[0] = isNaN(+pairSplit[0]) ? 0 : +pairSplit[0];
                    return [pairSplit[0], pairSplit[1]];
                }
                return [0, pair];
            });
            this.alignBreaks = this.alignBreaks.sort(function (a, b) { return a[0] > b[0] ? 1 : -1; });
        };
        CellComponent.prototype.setAlignActive = function () {
            var e_1, _a;
            if (!this.alignValue) {
                return;
            }
            try {
                for (var _b = __values(this.alignBreaks), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pair = _c.value;
                    if (window.innerWidth < pair[0]) {
                        break;
                    }
                    this.alignActive = pair[1];
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        CellComponent.prototype.applyAlign = function () {
            switch (this.alignActive) {
                case 't':
                case 'top':
                    this.alignSelf = 'flex-start';
                    break;
                case 'm':
                case 'middle':
                    this.alignSelf = 'center';
                    break;
                case 'b':
                case 'bottom':
                    this.alignSelf = 'flex-end';
                    break;
            }
        };
        return CellComponent;
    }());
    CellComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    selector: 'cell',
                    template: "<ng-content></ng-content>\r\n",
                    styles: ["cell{box-sizing:border-box;overflow:auto;position:relative;text-align:inherit}"]
                },] }
    ];
    CellComponent.ctorParameters = function () { return []; };
    CellComponent.propDecorators = {
        alignValue: [{ type: i0.Input, args: ['align',] }],
        height: [{ type: i0.Input }],
        width: [{ type: i0.Input }],
        align: [{ type: i0.HostBinding, args: ['style.align',] }],
        alignSelf: [{ type: i0.HostBinding, args: ['style.alignSelf',] }]
    };

    var DataTableComponent = /** @class */ (function () {
        function DataTableComponent() {
            this.tHeadRows = [];
            this.tBodyRows = [];
            this.tFootRows = [];
        }
        DataTableComponent.prototype.ngOnInit = function () { };
        return DataTableComponent;
    }());
    DataTableComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    selector: 'data-table',
                    template: "<thead *ngIf=\"tHeadRows.length\">\r\n    <tr *ngFor=\"let row of tHeadRows\">\r\n        <th *ngFor=\"let cell of row\"\r\n            [attr.colspan]=\"cell.colspan\"\r\n            [attr.rowspan]=\"cell.rowspan\"\r\n            [ngClass]=\"cell.class\"\r\n        >{{ cell.value }}</th>\r\n    </tr>\r\n</thead>\r\n<tbody *ngIf=\"tBodyRows.length\">\r\n    <tr *ngFor=\"let row of tBodyRows\">\r\n        <td *ngFor=\"let cell of row\"\r\n            [attr.colspan]=\"cell.colspan\"\r\n            [attr.rowspan]=\"cell.rowspan\"\r\n            [ngClass]=\"cell.class\"\r\n        >{{ cell.value }}</td>\r\n    </tr>\r\n</tbody>\r\n<tfoot *ngIf=\"tFootRows.length\">\r\n    <tr *ngFor=\"let row of tFootRows\">\r\n        <th *ngFor=\"let cell of row\"\r\n            [attr.colspan]=\"cell.colspan\"\r\n            [attr.rowspan]=\"cell.rowspan\"\r\n            [ngClass]=\"cell.class\"\r\n        >{{ cell.value }}</th>\r\n    </tr>\r\n</tfoot>\r\n",
                    styles: ["data-table{border-collapse:collapse;display:table;min-width:100%}data-table thead tr:first-of-type th{border-top:none}data-table thead th{background:#2294d3;border:1px solid #d3d3d3;color:#fff;height:30px;padding:10px;position:-webkit-sticky;position:sticky;top:0}data-table tbody td{border:1px solid #d3d3d3;padding:10px;text-align:center}data-table tfoot th{background:#2294d3;border:1px solid #d3d3d3;color:#fff;height:30px;padding:10px}"]
                },] }
    ];
    DataTableComponent.ctorParameters = function () { return []; };
    DataTableComponent.propDecorators = {
        tHeadRows: [{ type: i0.Input, args: ['thead-rows',] }],
        tBodyRows: [{ type: i0.Input, args: ['tbody-rows',] }],
        tFootRows: [{ type: i0.Input, args: ['tfoot-rows',] }]
    };

    var FlexButtonsComponent = /** @class */ (function () {
        function FlexButtonsComponent(element, renderer) {
            this.element = element;
            this.renderer = renderer;
        }
        FlexButtonsComponent.prototype.ngAfterViewInit = function () {
            this.applySpace();
        };
        FlexButtonsComponent.prototype.applySpace = function () {
            var e_1, _a;
            if (this.space) {
                try {
                    for (var _b = __values(this.element.nativeElement.children), _c = _b.next(); !_c.done; _c = _b.next()) {
                        var child = _c.value;
                        this.renderer.setStyle(child, 'margin', this.space);
                    }
                }
                catch (e_1_1) { e_1 = { error: e_1_1 }; }
                finally {
                    try {
                        if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                    }
                    finally { if (e_1) throw e_1.error; }
                }
            }
        };
        return FlexButtonsComponent;
    }());
    FlexButtonsComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    selector: 'flex-buttons',
                    template: "<ng-content></ng-content>\r\n",
                    styles: ["flex-buttons{bottom:0;display:flex;left:0;padding:1em;position:absolute;right:0;top:0}flex-buttons button{flex-basis:100%;flex-grow:1;margin:5px}"]
                },] }
    ];
    FlexButtonsComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 }
    ]; };
    FlexButtonsComponent.propDecorators = {
        space: [{ type: i0.Input }]
    };

    var DEFAULT_DENOMINATOR = 12;
    var GridService = /** @class */ (function () {
        function GridService() {
            this.heightDenom = DEFAULT_DENOMINATOR;
            this.widthDenom = DEFAULT_DENOMINATOR;
        }
        GridService.prototype.initCells = function (cellElements, heightDenom, heightScale, widthDenom) {
            this.heightDenom = heightDenom ? +heightDenom : DEFAULT_DENOMINATOR;
            this.heightScale = heightScale;
            this.widthDenom = widthDenom ? +widthDenom : DEFAULT_DENOMINATOR;
            this.cellElements = Array.from(cellElements) || [];
            this.readHeightScales();
            this.readCellProps();
            this.readBreaks();
            this.updateView();
        };
        GridService.prototype.readHeightScales = function () {
            if (!this.heightScale) {
                this.heightScaleCurrent = 1;
                return;
            }
            this.heightScale = this.trim(this.heightScale);
            this.breakHeightScales = this.splitBreaks(this.heightScale);
            this.breakHeightScales = this.breakHeightScales.sort(function (a, b) { return a[0] > b[0] ? 1 : -1; });
        };
        GridService.prototype.getCurrentHeightScaleBreak = function () {
            var e_1, _a;
            if (!this.heightScale) {
                this.heightScaleCurrent = 1;
                return;
            }
            var heightScale = 1;
            try {
                for (var _b = __values(this.breakHeightScales), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pair = _c.value;
                    if (window.innerHeight >= pair[0]) {
                        heightScale = +pair[1];
                    }
                    else {
                        break;
                    }
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
            this.heightScaleCurrent = heightScale;
        };
        GridService.prototype.readCellProps = function () {
            var _this = this;
            var strippedHeight;
            var strippedWidth;
            this.cellPropValues = [];
            this.cellElements.forEach(function (cell) {
                strippedHeight = cell.attributes['height'] ? cell.attributes['height'].value : '';
                strippedWidth = cell.attributes['width'] ? cell.attributes['width'].value : '';
                _this.cellPropValues.push({
                    height: _this.trim(strippedHeight),
                    width: _this.trim(strippedWidth)
                });
            });
        };
        GridService.prototype.trim = function (value) {
            while (value.match(/\s\s/)) {
                value = value.replace(/\s\s/, ' ');
            }
            value = value.replace(/^\s/, '');
            value = value.replace(/\s$/, '');
            return value;
        };
        GridService.prototype.readBreaks = function () {
            var _this = this;
            this.breaks = [];
            this.cellPropValues.forEach(function (_a) {
                var height = _a.height, width = _a.width;
                _this.breakHeights = [];
                _this.breakWidths = [[0, _this.widthDenom]];
                if (height) {
                    _this.breakHeights = _this.splitBreaks(height);
                    _this.breakHeights = _this.breakHeights
                        .sort(function (a, b) { return a[0] > b[0] ? 1 : -1; });
                }
                if (width) {
                    _this.breakWidths = _this.splitBreaks(width);
                    _this.breakWidths = _this.breakWidths
                        .sort(function (a, b) { return a[0] > b[0] ? 1 : -1; });
                }
                _this.breaks.push({
                    heights: _this.breakHeights,
                    widths: _this.breakWidths
                });
            });
        };
        GridService.prototype.splitBreaks = function (value) {
            var pairs = value.split(' ');
            var pairSplit;
            return pairs.map(function (pair) {
                if (pair.match(/:/)) {
                    pairSplit = pair.split(':');
                    pairSplit[0] = isNaN(+pairSplit[0]) ? 0 : +pairSplit[0];
                    pairSplit[1] = !pairSplit[1] ? 0 : pairSplit[1];
                    return [pairSplit[0], pairSplit[1]];
                }
                return [0, pair];
            });
        };
        GridService.prototype.updateView = function () {
            this.getCurrentBreakValues();
            this.getCurrentHeightScaleBreak();
            this.setCalcValues();
            this.applyStyles();
        };
        GridService.prototype.getCurrentBreakValues = function () {
            var _this = this;
            var endRow;
            var rowFixedRunner = 0;
            var rowFlexRunner = 0;
            var rowIndex = 0;
            this.cellRowIndexes = [];
            this.currentCellValues = [];
            this.rowFixedTotals = [];
            if (this.breaks) {
                this.breaks.forEach(function (cell, index) {
                    var height = _this.processPairHeights(cell);
                    var width = _this.processPairWidths(cell);
                    if (height && !height.match(/px/) && !height.match(/%/) && !height.match(/\//)) {
                        height = (+height / _this.heightDenom * 100) + '%';
                    }
                    if (width.match(/!/)) {
                        endRow = true;
                        width = width.replace('!', '');
                    }
                    if (width.match(/px/)) {
                        rowFixedRunner += +width.replace('px', '');
                    }
                    else {
                        if (rowFlexRunner === 1) {
                            _this.rowFixedTotals.push(rowFixedRunner);
                            rowIndex++;
                            rowFlexRunner = 0;
                            rowFixedRunner = 0;
                        }
                        rowFlexRunner += +width / _this.widthDenom;
                        width = (+width / _this.widthDenom * 100) + '%';
                    }
                    _this.cellRowIndexes[index] = rowIndex;
                    if (endRow) {
                        _this.rowFixedTotals.push(rowFixedRunner);
                        rowIndex++;
                        endRow = false;
                        rowFlexRunner = 0;
                        rowFixedRunner = 0;
                    }
                    _this.currentCellValues.push({ height: height, width: width });
                });
            }
            this.rowFixedTotals.push(rowFixedRunner);
        };
        GridService.prototype.processPairHeights = function (cell) {
            var e_2, _a;
            var windowWidth = window.innerWidth;
            var height = '';
            try {
                for (var _b = __values(cell.heights), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pair = _c.value;
                    if (windowWidth >= pair[0]) {
                        height = pair[1];
                    }
                    else {
                        break;
                    }
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
            return height.toString();
        };
        GridService.prototype.processPairWidths = function (cell) {
            var e_3, _a;
            var windowWidth = window.innerWidth;
            var width = DEFAULT_DENOMINATOR;
            try {
                for (var _b = __values(cell.widths), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pair = _c.value;
                    if (windowWidth >= pair[0]) {
                        width = pair[1];
                    }
                    else {
                        break;
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return width.toString();
        };
        GridService.prototype.setCalcValues = function () {
            var _this = this;
            this.cellStyles = [];
            this.currentCellValues.forEach(function (_a, index) {
                var height = _a.height, width = _a.width;
                if (!width.match('px')) {
                    var decimal = 0.01 * +width.replace('%', '');
                    width = "calc((100% - " + _this.rowFixedTotals[_this.cellRowIndexes[index]] + "px) * " + decimal + ")";
                }
                _this.cellStyles.push({ height: height, width: width });
            });
        };
        GridService.prototype.applyStyles = function () {
            var _this = this;
            this.cellStyles.forEach(function (_a, index) {
                var height = _a.height, width = _a.width;
                _this.setHeightStyle(height, index, width);
                _this.cellElements[index].style.width = width;
            });
        };
        GridService.prototype.setHeightStyle = function (height, index, width) {
            if (height.match('/')) {
                this.setHeightRatioStyles(height, index, width);
                return;
            }
            var pair = height.split('-');
            if (+pair[0]) {
                pair[0] = ((+pair[0] / this.heightDenom) * 100 * this.heightScaleCurrent) + 'vh';
            }
            else if (pair[0].match('%')) {
                var mainHeight = pair[0].split('%')[0];
                var heightWithScale = +mainHeight * this.heightScaleCurrent;
                pair[0] = heightWithScale + 'vh';
            }
            height = height.match('-') ? "calc(" + pair[0] + " - " + pair[1] + ")" : pair[0];
            this.cellElements[index].style.height = height;
        };
        GridService.prototype.setHeightRatioStyles = function (height, index, width) {
            var percentage = width.split('* ')[1];
            percentage = percentage.split(')')[0];
            var fraction = height.split('/');
            // no height scaling for ratios because ratio would break
            var ratio = ((+fraction[1] / +fraction[0]) * (100 * +percentage)) + '%';
            this.cellElements[index].style.height = '0';
            this.cellElements[index].style.paddingTop = ratio;
        };
        return GridService;
    }());
    GridService.ɵprov = i0.ɵɵdefineInjectable({ factory: function GridService_Factory() { return new GridService(); }, token: GridService, providedIn: "root" });
    GridService.decorators = [
        { type: i0.Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    GridService.ctorParameters = function () { return []; };

    var GridComponent = /** @class */ (function () {
        function GridComponent(element, gridService) {
            this.element = element;
            this.gridService = gridService;
        }
        GridComponent.prototype.onResize = function () {
            this.gridService.updateView();
        };
        GridComponent.prototype.ngOnInit = function () { };
        GridComponent.prototype.ngOnChanges = function () {
            var _this = this;
            setTimeout(function () {
                _this.gridService.initCells(_this.element.nativeElement.children, _this.heightDenom, _this.heightScale, _this.widthDenom);
            }, 0);
        };
        GridComponent.prototype.ngAfterViewInit = function () {
            this.gridService.initCells(this.element.nativeElement.children, this.heightDenom, this.heightScale, this.widthDenom);
        };
        return GridComponent;
    }());
    GridComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    providers: [GridService],
                    selector: 'grid',
                    template: "<ng-content></ng-content>\r\n",
                    styles: ["grid{display:flex;flex-wrap:wrap;position:relative}"]
                },] }
    ];
    GridComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: GridService }
    ]; };
    GridComponent.propDecorators = {
        heightDenom: [{ type: i0.Input, args: ['height-denom',] }],
        heightScale: [{ type: i0.Input, args: ['height-scale',] }],
        update: [{ type: i0.Input }],
        widthDenom: [{ type: i0.Input, args: ['width-denom',] }],
        onResize: [{ type: i0.HostListener, args: ['window:resize', [],] }]
    };

    var MetricComponent = /** @class */ (function () {
        function MetricComponent() {
        }
        return MetricComponent;
    }());
    MetricComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    selector: 'metric',
                    template: "<main>\r\n    <div [ngStyle]=\"valueStyle\">{{ value }}</div>\r\n    <div *ngIf=\"caption\" [ngStyle]=\"captionStyle\">{{ caption }}</div>\r\n</main>\r\n",
                    styles: ["metric{bottom:0;display:table;height:100%;left:0;position:absolute;right:0;top:0;width:100%}metric>main{display:table-cell;overflow:hidden;text-align:center;vertical-align:middle}metric>main>div:first-of-type{font-size:24px;font-weight:700;text-overflow:ellipsis;white-space:nowrap}metric>main>div:nth-of-type(2){color:grey;font-size:14px;font-weight:700}"]
                },] }
    ];
    MetricComponent.ctorParameters = function () { return []; };
    MetricComponent.propDecorators = {
        caption: [{ type: i0.Input }],
        captionStyle: [{ type: i0.Input, args: ['style-caption',] }],
        value: [{ type: i0.Input }],
        valueStyle: [{ type: i0.Input, args: ['style-value',] }]
    };

    var StatementComponent = /** @class */ (function () {
        function StatementComponent() {
        }
        return StatementComponent;
    }());
    StatementComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    selector: 'statement',
                    template: "<header *ngIf=\"title\" [ngStyle]=\"titleStyle\">{{ title }}</header>\r\n<main [ngStyle]=\"contentStyle\"><ng-content></ng-content></main>\r\n",
                    styles: ["statement{display:block;line-height:1.5;padding:0}statement>header{font-size:18px;font-weight:700}statement>main{font-size:13px}"]
                },] }
    ];
    StatementComponent.ctorParameters = function () { return []; };
    StatementComponent.propDecorators = {
        title: [{ type: i0.Input }],
        contentStyle: [{ type: i0.Input, args: ['style-content',] }],
        titleStyle: [{ type: i0.Input, args: ['style-title',] }]
    };

    var TabComponent = /** @class */ (function () {
        function TabComponent() {
        }
        return TabComponent;
    }());
    TabComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    selector: 'tab',
                    template: "<ng-content></ng-content>\r\n",
                    styles: ["tab{width:100%}"]
                },] }
    ];
    TabComponent.ctorParameters = function () { return []; };
    TabComponent.propDecorators = {
        title: [{ type: i0.Input }]
    };

    var hostStyles = {
        boxShadow: '1px 1px 2px black'
    };
    var headerStyles = {
        background: 'transparent',
        color: 'dimgray',
        display: 'flex',
        fontWeight: 'bold',
        left: 0,
        position: 'absolute',
        right: 0,
        textAlign: 'center',
        top: 0,
        whiteSpace: 'nowrap',
        zIndex: 1
    };
    var mainStyles = {
        background: 'white',
        bottom: 0,
        left: 0,
        overflow: 'auto',
        padding: '1em',
        position: 'absolute',
        right: 0
    };
    var tabActiveStyles = {
        background: '#e6e6e6',
        borderRight: '1px solid gray',
        color: '#340096',
        flexGrow: 1,
        fontSize: '16px',
        height: '32px',
        lineHeight: '32px',
        margin: 0,
        overflow: 'hidden',
        padding: '0 15px',
        position: 'relative',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap'
    };
    var tabIdleStyles = {
        background: 'lightgray',
        borderRight: '1px solid gray',
        flexGrow: 1,
        height: '32px',
        lineHeight: '32px',
        margin: 0,
        overflow: 'hidden',
        padding: '0 15px',
        position: 'relative',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap'
    };
    var tabHoverStyles = {
        background: '#e6e6e6',
        borderRight: '1px solid gray',
        cursor: 'pointer',
        flexGrow: 1,
        height: '32px',
        lineHeight: '32px',
        margin: 0,
        overflow: 'hidden',
        padding: '0 15px',
        position: 'relative',
        textOverflow: 'ellipsis',
        whiteSpace: 'nowrap'
    };

    var TileComponent = /** @class */ (function () {
        function TileComponent(element, renderer) {
            this.element = element;
            this.renderer = renderer;
            this.hover = -1;
            this.marginActive = '';
            this.marginBreaks = [];
            this.paddingActive = '';
            this.paddingBreaks = [];
            this.positionStyles = {};
            this.tabTitles = [];
            this.boxShadowInput = '';
            this.fullScreenChange = new i0.EventEmitter();
            this.tabChange = new i0.EventEmitter();
            this.boxShadow = this.boxShadowInput || hostStyles.boxShadow;
        }
        TileComponent.prototype.onResize = function () {
            this.updateView();
        };
        TileComponent.prototype.ngOnInit = function () {
            var tileTab = localStorage.getItem('tile-tab');
            this.activeTab = (this.tabSave && tileTab) ? +tileTab : +this.tab || 0;
            this.setContainerPositions();
            this.setStyles();
            this.marginBreaks = this.setBreaks(this.marginValue);
            this.paddingBreaks = this.setBreaks(this.paddingValue);
            this.updateView();
            this.setTabState();
            this.updateActiveTab(this.activeTab);
        };
        TileComponent.prototype.ngOnChanges = function () {
            this.updateActiveTab(this.tab);
        };
        TileComponent.prototype.setContainerPositions = function () {
            this.positionStyles = {};
            if (!this.element.nativeElement.parentNode.attributes.getNamedItem('height')) {
                this.positionStyles = {
                    position: 'relative',
                    top: ''
                };
                this.renderer.setStyle(this.element.nativeElement, 'position', 'relative');
            }
        };
        TileComponent.prototype.setStyles = function () {
            this.styleMain = Object.assign(Object.assign(Object.assign({}, mainStyles), this.positionStyles), this.styleMain);
            this.styleHeader = Object.assign(Object.assign(Object.assign({}, headerStyles), this.positionStyles), this.styleHeader);
            this.styleTabActive = Object.assign(Object.assign({}, tabActiveStyles), this.styleTabActive);
            this.styleTabHover = Object.assign(Object.assign({}, tabHoverStyles), this.styleTabHover);
            this.styleTabIdle = Object.assign(Object.assign({}, tabIdleStyles), this.styleTabIdle);
        };
        TileComponent.prototype.setBreaks = function (value) {
            if (!value) {
                return [];
            }
            var pairs = value.split(' ');
            var breaks = pairs.map(function (pair) {
                if (pair.match(/:/)) {
                    var pairSplit = pair.split(':');
                    pairSplit[0] = isNaN(+pairSplit[0]) ? 0 : +pairSplit[0];
                    return [pairSplit[0], pairSplit[1]];
                }
                return [0, pair];
            });
            return breaks.sort(function (a, b) { return a[0] > b[0] ? 1 : -1; });
        };
        TileComponent.prototype.updateView = function () {
            this.setMarginActive();
            this.setPaddingActive();
            this.setTileSize();
        };
        TileComponent.prototype.setMarginActive = function () {
            var e_1, _a;
            if (!this.marginValue) {
                return;
            }
            try {
                for (var _b = __values(this.marginBreaks), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pair = _c.value;
                    if (window.innerWidth < pair[0]) {
                        break;
                    }
                    this.marginActive = pair[1];
                }
            }
            catch (e_1_1) { e_1 = { error: e_1_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_1) throw e_1.error; }
            }
        };
        TileComponent.prototype.setPaddingActive = function () {
            var e_2, _a;
            if (!this.paddingValue) {
                return;
            }
            try {
                for (var _b = __values(this.paddingBreaks), _c = _b.next(); !_c.done; _c = _b.next()) {
                    var pair = _c.value;
                    if (window.innerWidth < pair[0]) {
                        break;
                    }
                    this.paddingActive = pair[1];
                }
            }
            catch (e_2_1) { e_2 = { error: e_2_1 }; }
            finally {
                try {
                    if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
                }
                finally { if (e_2) throw e_2.error; }
            }
        };
        TileComponent.prototype.setTileSize = function () {
            this.marginActive = this.marginActive.replace('px', '') || '2';
            this.height = this.width = 'calc(100% - ' + (+this.marginActive * 2) + 'px)';
            this.margin = this.marginActive + 'px';
            if (this.paddingActive) {
                this.styleMain = Object.assign(Object.assign({}, this.styleMain), { padding: this.paddingActive });
            }
        };
        TileComponent.prototype.setTabState = function () {
            this.mainElement = this.element.nativeElement.children[0];
            if (this.mainElement) {
                var mainTabs = this.mainElement.children;
                var length = mainTabs.length;
                this.tabElements = [];
                if (mainTabs.length && mainTabs[0].nodeName === 'TAB') {
                    for (var i = 0; i < length; i++) {
                        var title = mainTabs[0].attributes['title'];
                        if (title && title.value) {
                            this.tabTitles.push(title.value);
                        }
                        this.tabElements.push(mainTabs[0]);
                        this.renderer.removeChild(this.mainElement, mainTabs[0]);
                    }
                }
            }
        };
        TileComponent.prototype.toggleFullScreen = function () {
            this.fullScreenActive = !this.fullScreenActive;
            this.fullScreenActive ? this.applyFullScreen() : this.cancelFullScreen();
            this.fullScreenChange.emit(this.fullScreenActive);
        };
        TileComponent.prototype.applyFullScreen = function () {
            var _this = this;
            // TODO: convert to class and properties
            [
                ['margin', '2px'],
                ['position', 'fixed'],
                ['top', '0'],
                ['left', '0'],
                ['right', '0'],
                ['bottom', '0'],
                ['width', 'auto'],
                ['height', 'auto'],
                ['zIndex', '2']
            ].forEach(function (item) { return _this.renderer.setStyle(_this.element.nativeElement, item[0], item[1]); });
        };
        TileComponent.prototype.cancelFullScreen = function () {
            var _this = this;
            // TODO: change to class
            [
                ['margin', this.margin],
                ['position', 'absolute'],
                ['top', '0'],
                ['left', ''],
                ['right', ''],
                ['bottom', ''],
                ['width', this.width],
                ['height', this.height],
                ['zIndex', '']
            ].forEach(function (item) { return _this.renderer.setStyle(_this.element.nativeElement, item[0], item[1]); });
        };
        TileComponent.prototype.updateActiveTab = function (index) {
            if (this.tab === undefined || !this.tabElements) {
                return;
            }
            if (this.activeTab !== index && this.tabElements[this.activeTab]) {
                this.renderer.removeChild(this.mainElement, this.tabElements[this.activeTab]);
            }
            if (this.tabElements[index]) {
                this.renderer.appendChild(this.mainElement, this.tabElements[index]);
            }
            this.activeTab = index;
            if (this.tabSave) {
                localStorage.setItem('tile-tab', this.activeTab.toString());
            }
            this.tabChange.emit(this.activeTab);
        };
        return TileComponent;
    }());
    TileComponent.decorators = [
        { type: i0.Component, args: [{
                    encapsulation: i0.ViewEncapsulation.None,
                    selector: 'tile',
                    template: "<header *ngIf=\"fullScreen || title\" [ngStyle]=\"styleHeader\">\r\n    <span *ngIf=\"!tabTitles.length && title\"\r\n          [ngStyle]=\"styleTabActive\"\r\n          [title]=\"title\">\r\n        {{ title }}\r\n    </span>\r\n    <span *ngFor=\"let tab of tabTitles; let index = index;\"\r\n          [ngStyle]=\"hover === index && activeTab !== index ? styleTabHover : index === activeTab ? styleTabActive : styleTabIdle\"\r\n          [title]=\"tab\"\r\n          (click)=\"updateActiveTab(index)\"\r\n          (mouseout)=\"hover = -1\"\r\n          (mouseover)=\"hover = index\">\r\n        {{ tab }}\r\n    </span>\r\n    <span *ngIf=\"fullScreen\"\r\n          title=\"Expand/Collapse\"\r\n          [ngStyle]=\"hover === -2 ? styleTabHover : styleTabIdle\"\r\n          (click)=\"fullScreen && toggleFullScreen()\"\r\n          (mouseout)=\"hover = -1\"\r\n          (mouseover)=\"hover = -2\">\r\n        <div></div>\r\n        <div></div>\r\n    </span>\r\n</header>\r\n<main\r\n    [style.top]=\"fullScreen || title ? '32px' : '0'\"\r\n    [ngStyle]=\"styleMain\"\r\n>\r\n    <ng-content></ng-content>\r\n</main>\r\n",
                    styles: ["tile{background:#fff;box-sizing:border-box;display:block;position:absolute;top:0}tile>header>span:last-of-type{border-right:none!important}tile>header>span>div{background:none;border:3px solid #696969;height:2px;position:absolute;width:2px}tile>header>span>div:first-of-type{border-bottom-color:transparent;border-left-color:transparent;right:10px;top:10px}tile>header>span>div:nth-of-type(2){border-right-color:transparent;border-top-color:transparent;right:13px;top:13px}"]
                },] }
    ];
    TileComponent.ctorParameters = function () { return [
        { type: i0.ElementRef },
        { type: i0.Renderer2 }
    ]; };
    TileComponent.propDecorators = {
        boxShadowInput: [{ type: i0.Input, args: ['box-shadow',] }],
        fullScreen: [{ type: i0.Input, args: ['full-screen',] }],
        marginValue: [{ type: i0.Input, args: ['margin',] }],
        paddingValue: [{ type: i0.Input, args: ['padding',] }],
        styleHeader: [{ type: i0.Input, args: ['style-header',] }],
        styleMain: [{ type: i0.Input, args: ['style-main',] }],
        styleTabActive: [{ type: i0.Input, args: ['style-tab-active',] }],
        styleTabIdle: [{ type: i0.Input, args: ['style-tab-idle',] }],
        styleTabHover: [{ type: i0.Input, args: ['style-tab-hover',] }],
        tab: [{ type: i0.Input }],
        tabSave: [{ type: i0.Input, args: ['tab-save',] }],
        title: [{ type: i0.Input }],
        fullScreenChange: [{ type: i0.Output, args: ['full-screen-change',] }],
        tabChange: [{ type: i0.Output, args: ['tab-change',] }],
        boxShadow: [{ type: i0.HostBinding, args: ['style.boxShadow',] }],
        height: [{ type: i0.HostBinding, args: ['style.height',] }],
        margin: [{ type: i0.HostBinding, args: ['style.margin',] }],
        width: [{ type: i0.HostBinding, args: ['style.width',] }],
        onResize: [{ type: i0.HostListener, args: ['window:resize', [],] }]
    };

    var NgMixUiModule = /** @class */ (function () {
        function NgMixUiModule() {
        }
        return NgMixUiModule;
    }());
    NgMixUiModule.decorators = [
        { type: i0.NgModule, args: [{
                    declarations: [
                        CellComponent,
                        DataTableComponent,
                        FlexButtonsComponent,
                        GridComponent,
                        MetricComponent,
                        StatementComponent,
                        TabComponent,
                        TileComponent
                    ],
                    imports: [
                        common.CommonModule
                    ],
                    exports: [
                        CellComponent,
                        DataTableComponent,
                        FlexButtonsComponent,
                        GridComponent,
                        MetricComponent,
                        StatementComponent,
                        TabComponent,
                        TileComponent
                    ]
                },] }
    ];

    /**
     * Generated bundle index. Do not edit.
     */

    exports.CellComponent = CellComponent;
    exports.DataTableComponent = DataTableComponent;
    exports.FlexButtonsComponent = FlexButtonsComponent;
    exports.GridComponent = GridComponent;
    exports.MetricComponent = MetricComponent;
    exports.NgMixUiModule = NgMixUiModule;
    exports.StatementComponent = StatementComponent;
    exports.TabComponent = TabComponent;
    exports.TileComponent = TileComponent;
    exports.ɵa = GridService;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ng-mix-ui.umd.js.map
