export declare class GridService {
    breakHeights: [number, string | number][];
    breakHeightScales: [number, string | number][];
    breaks: {
        heights: [number, string | number][];
        widths: [number, string | number][];
    }[];
    breakWidths: [number, string | number][];
    cellElements: HTMLElement[];
    cellPropValues: {
        height: string;
        width: string;
    }[];
    cellStyles: {
        height: string;
        width: string;
    }[];
    cellRowIndexes: {};
    currentCellValues: {
        height: string;
        width: string;
    }[];
    heightDenom: number;
    heightScale: string;
    heightScaleCurrent: number;
    rowFixedTotals: number[];
    widthDenom: number;
    constructor();
    initCells(cellElements: HTMLElement[], heightDenom: string, heightScale: string, widthDenom: string): void;
    readHeightScales(): void;
    getCurrentHeightScaleBreak(): void;
    readCellProps(): void;
    trim(value: string): string;
    readBreaks(): void;
    splitBreaks(value: string): [number, string][];
    updateView(): void;
    getCurrentBreakValues(): void;
    processPairHeights(cell: any): string;
    processPairWidths(cell: any): string;
    setCalcValues(): void;
    applyStyles(): void;
    setHeightStyle(height: string, index: number, width: string): void;
    setHeightRatioStyles(height: string, index: number, width: string): void;
}
